import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import time
import string
import psyco
from xpints import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Sound Engine'
info.version = '1.0.22'
info.basename = '10pintsSoundengne'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'

'''
Sounds Need to be in 24kbps-320kbps (1,2,4)(11025hz) mono .mp3 or .wav
'''

psyco.full()

sounddata = shelve.open(es.getAddonPath('xpints') + '/data/soundengine.data', writeback=True)

################################################################################
#						 													  #
#						         Game Events                                  #
#																			  #
################################################################################
def load():
	global engine
	engine = soundEngine()
	
def unload():
	engine.unload()

def round_start(ev):
	engine.ambient()
	
def round_end(ev):
	engine.roundEnd(ev)
	
def es_map_start(ev):
	engine.addDownloads()
	random.seed()
	
def player_hurt(ev):
	engine.playerHurt(ev)
	
def player_activate(ev):
	engine.updateUser(ev)
	
	
################################################################################
#						 													  #
#						        Global Functions                              #
#																			  #
################################################################################
	
def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
################################################################################
#						 													  #
#						       Sound Engine Class                             #
#																			  #
################################################################################
class soundEngine:
	def __init__(self):
		self.sounds = {}
		self.sounds['ambient'] = {
			0:'xpints/ambient/zombambient1.mp3',
			1:'xpints/ambient/zombambient2.mp3',
			2:'xpints/ambient/zombambient3.mp3',
			3:'xpints/ambient/zombambient4.mp3',
			4:'xpints/ambient/zombambient5.mp3',
			5:'xpints/ambient/zombambient6.mp3',
			6:'xpints/ambient/zombambient7.mp3'}
		
		self.sounds['zombie'] = {}
		self.sounds['zombie']['groan'] = {
			0:'xpints/zombie/groans/zomb7.mp3',
			1:'xpints/zombie/groans/groan1.mp3',
			2:'xpints/zombie/groans/groan2.mp3',
			3:'xpints/zombie/groans/groan3.mp3',
			4:'xpints/zombie/groans/groan4.mp3',
			5:'xpints/zombie/groans/groan5.mp3'}
		self.sounds['zombie']['hit'] = {
			0:'xpints/zombie/hit/zomb6.mp3',
			1:'xpints/zombie/hit/zombieHit1.mp3',
			2:'xpints/zombie/hit/zombieHit2.mp3',
			3:'xpints/zombie/hit/zombieHit3.mp3'}
		
		self.sounds['voice'] = {}
		self.sounds['voice']['Brad'] = {}
		self.sounds['voice']['Mitch'] = {}
		self.sounds['voice']['Pat'] = {}
		self.sounds['voice']['Jason'] = {}
		self.sounds['voice']['Rob'] = {}
		self.sounds['voice']['Liz'] = {}
		
	def getVoices(self):
		return self.sounds['voice']
		
	def setVoice(self,userid,voice):
		steamid = getSteamid(userid)
		sounddata[steamid]['voice'] = voice
		
	def updateUser(self,ev):
		steamid = getSteamid(ev['userid'])
		if sounddata.has_key(steamid):
			doshit = 1
		else:
			sounddata[steamid] = {'voice':0}
			
	def addDownloads(self):
		for sound in self.sounds['ambient']:
			es.stringtable('downloadables', 'sound/' + self.sounds['ambient'][sound])
		for sound in self.sounds['zombie']['groan']:
			es.stringtable('downloadables', 'sound/' + self.sounds['zombie']['groan'][sound])
		for sound in self.sounds['zombie']['hit']:
			es.stringtable('downloadables', 'sound/' + self.sounds['zombie']['hit'][sound])
	
	def ambient(self):
		time = random.randint(15,45)
		random.jumpahead(random.randint(0,9999))
		if random.randint(1,100) >= 50:
			sound = random.choice(self.sounds['ambient'])
			volume = float(random.randint(5,10) / 10.0)
			#es.dbgmsg(0,'Playing ' + sound)
			self.playSoundAll(sound, volume)
		list = playerlib.getPlayerList('#ct')
		for userid in list:
			delay = random.randint(1,30)
			sound = random.choice(self.sounds['zombie']['groan'])
			gamethread.delayedname(delay, 'sounds', self.emitSound, (userid, sound, 0.9 ))
			random.jumpahead(random.randint(0,9999))
			gamethread.delayedname(delay / 2, 'sounds', self.emitSound, (userid, sound, 0.9 ))
		gamethread.delayedname(time, 'sounds', self.ambient)
	
	def playerHurt(self,ev):
		victim = ev['userid']
		attacker = ev['attacker']
		if ev['health'] != '0':
			if random.randint(1,100) >= 90: #victim Sounds
				time = float(random.randint(0,5) / 10.0)
				if ev['es_userteam'] == '3':
					sound = random.choice(self.sounds['zombie']['hit'])
					#es.dbgmsg(0,'Playing ' + sound + ' in ' + str(time) + ' Seconds')
					gamethread.delayedname(time, 'sounds', self.emitSound, (victim, sound, 0.9 ))
				else:
					doshitforhavingahumanselectedvoiceherethatisverycomplicated = 1
			if random.randint(1,100) >= 80: #attacker Sounds
				time = float(random.randint(0,5) / 10.0)
				if es.getplayerteam(attacker) == 3:
					sound = random.choice(self.sounds['zombie']['groan'])
					#es.dbgmsg(0,'Playing ' + sound + ' in ' + str(time) + ' Seconds')
					gamethread.delayedname(time, 'sounds', self.emitSound, (attacker, sound, 0.9 ))
				else:
					doshitforhavingahumanselectedvoiceherethatisverycomplicated = 1
				
	def emitSound(self,userid,sound,volume):
		es.emitsound('player', userid, sound, 1.0, volume)
	def playSoundAll(self,sound,volume):
		for x in playerlib.getPlayerList('#human'):
			es.playsound(x.userid,sound,volume)
	def playSound(self,sound,userid,volume):
		es.playsound(userid,sound,volume)
	
	def roundEnd(self,ev):
		gamethread.cancelDelayed('sounds')
		
	def unload(self):
		gamethread.cancelDelayed('sounds')
				
		
		
##################################################################################################
#EOF
##################################################################################################